Index: inc/admin/lib.moduleslist.php
===================================================================
--- inc/admin/lib.moduleslist.php	(revision 2490)
+++ inc/admin/lib.moduleslist.php	(revision 2327)
@@ -146,6 +146,6 @@
 	public function isDeletablePath($root)
 	{
-		return $this->path_writable
-			&& (preg_match('!^'.$this->path_pattern.'!', $root) || defined('DC_DEV') && DC_DEV)
+		return $this->path_writable 
+			&& (preg_match('!^'.$this->path_pattern.'!', $root) || defined('DC_DEV') && DC_DEV) 
 			&& $this->core->auth->isSuperAdmin();
 	}
@@ -256,5 +256,5 @@
 		}
 
-		echo
+		echo 
 		'<div class="modules-search">'.
 		'<form action="'.$this->getURL().'" method="get">'.
@@ -263,10 +263,10 @@
 		'<input type="submit" value="'.__('OK').'" /> ';
 
-		if ($query) {
-			echo
+		if ($query) { 
+			echo 
 			' <a href="'.$this->getURL().'" class="button">'.__('Reset search').'</a>';
 		}
 
-		echo
+		echo 
 		'</p>'.
 		'<p class="form-note">'.
@@ -276,7 +276,7 @@
 
 		if ($query) {
-			echo
+			echo 
 			'<p class="message">'.sprintf(
-				__('Found %d result for search "%s":', 'Found %d results for search "%s":', count($this->data)),
+				__('Found %d result for search "%s":', 'Found %d results for search "%s":', count($this->data)), 
 				count($this->data), html::escapeHTML($query)
 				).
@@ -349,10 +349,10 @@
 			# Letter having modules
 			elseif (!empty($indexes[$char])) {
-				$title = sprintf(__('%d result', '%d results', $indexes[$char]), $indexes[$char]);
+				$title = sprintf(__('%d module', '%d modules', $indexes[$char]), $indexes[$char]);
 				$buttons[] = '<li class="btn" title="'.$title.'"><a href="'.$this->getURL('m_nav='.$char).'" title="'.$title.'"> '.$char.' </a></li>';
 			}
 			# Letter without modules
 			else {
-				$buttons[] = '<li class="btn no-link" title="'.__('no results').'"> '.$char.' </li>';
+				$buttons[] = '<li class="btn no-link" title="'.__('no module').'"> '.$char.' </li>';
 			}
 		}
@@ -434,6 +434,6 @@
 	 * Sanitize a module.
 	 *
-	 * This clean infos of a module by adding default keys
-	 * and clean some of them, sanitize module can safely
+	 * This clean infos of a module by adding default keys 
+	 * and clean some of them, sanitize module can safely 
 	 * be used in lists.
 	 *
@@ -444,5 +444,5 @@
 		$label = empty($module['label']) ? $id : $module['label'];
 		$name = __(empty($module['name']) ? $label : $module['name']);
-
+		
 		return array_merge(
 			# Default values
@@ -521,53 +521,44 @@
 	public function displayModules($cols=array('name', 'version', 'desc'), $actions=array(), $nav_limit=false)
 	{
-		echo
-		'<form action="'.$this->getURL().'" method="post" class="modules-form-actions">'.
+		echo 
 		'<div class="table-outer">'.
 		'<table id="'.html::escapeHTML($this->list_id).'" class="modules'.(in_array('expander', $cols) ? ' expandable' : '').'">'.
-		'<caption class="hidden">'.html::escapeHTML(__('Plugins list')).'</caption><tr>';
+		'<caption class="hidden">'.html::escapeHTML(__('Modules list')).'</caption><tr>';
 
 		if (in_array('name', $cols)) {
-			$colspan = 1;
-			if (in_array('checkbox', $cols)) {
-				$colspan++;
-			}
-			if (in_array('icon', $cols)) {
-				$colspan++;
-			}
-			echo
-			'<th class="first nowrap"'.($colspan > 1 ? ' colspan="'.$colspan.'"' : '').'>'.__('Name').'</th>';
+			echo 
+			'<th class="first nowrap"'.(in_array('icon', $cols) ? ' colspan="2"' : '').'>'.__('Name').'</th>';
 		}
 
 		if (in_array('score', $cols) && $this->getSearch() !== null && defined('DC_DEBUG') && DC_DEBUG) {
-			echo
+			echo 
 			'<th class="nowrap">'.__('Score').'</th>';
 		}
 
 		if (in_array('version', $cols)) {
-			echo
+			echo 
 			'<th class="nowrap count" scope="col">'.__('Version').'</th>';
 		}
 
 		if (in_array('current_version', $cols)) {
-			echo
+			echo 
 			'<th class="nowrap count" scope="col">'.__('Current version').'</th>';
 		}
 
 		if (in_array('desc', $cols)) {
-			echo
+			echo 
 			'<th class="nowrap" scope="col">'.__('Details').'</th>';
 		}
 
 		if (in_array('distrib', $cols)) {
-			echo
-			'<th'.(in_array('desc', $cols) ? '' : ' class="maximal"').'></th>';
+			echo '<th'.(in_array('desc', $cols) ? '' : ' class="maximal"').'></th>';
 		}
 
 		if (!empty($actions) && $this->core->auth->isSuperAdmin()) {
-			echo
+			echo 
 			'<th class="minimal nowrap">'.__('Action').'</th>';
 		}
 
-		echo
+		echo 
 		'</tr>';
 
@@ -593,82 +584,51 @@
 			}
 
-			echo
+			echo 
 			'<tr class="line" id="'.html::escapeHTML($this->list_id).'_m_'.html::escapeHTML($id).'">';
 
-			$tds = 0;
-
-			if (in_array('checkbox', $cols)) {
-				$tds++;
-				echo
-				'<td class="module-icon nowrap">'.
-				form::checkbox(array('modules['.$count.']', html::escapeHTML($this->list_id).'_modules_'.html::escapeHTML($id)), html::escapeHTML($id)).
-				'</td>';
-			}
-
 			if (in_array('icon', $cols)) {
-				$tds++;
-				echo
+				echo 
 				'<td class="module-icon nowrap">'.sprintf(
-					'<img alt="%1$s" title="%1$s" src="%2$s" />',
+					'<img alt="%1$s" title="%1$s" src="%2$s" />', 
 					html::escapeHTML($id), file_exists($module['root'].'/icon.png') ? 'index.php?pf='.$id.'/icon.png' : 'images/module.png'
 				).'</td>';
 			}
 
-			$tds++;
-			echo
-			'<td class="module-name nowrap" scope="row">';
-			if (in_array('checkbox', $cols)) {
-				if (in_array('expander', $cols)) {
-					echo
-					html::escapeHTML($module['name']);
-				}
-				else {
-					echo
-					'<label for="'.html::escapeHTML($this->list_id).'_modules_'.html::escapeHTML($id).'">'.
-					html::escapeHTML($module['name']).
-					'</label>';
-				}
-			}
-			else {
-				echo
-				html::escapeHTML($module['name']).
-				form::hidden(array('modules['.$count.']'), html::escapeHTML($id));
-			}
-			echo
-			$this->core->formNonce().
-			'</td>';
+			# Link to config file
+			$config = in_array('config', $cols) && !empty($module['root']) && file_exists(path::real($module['root'].'/_config.php'));
+
+			echo 
+			'<td class="module-name nowrap" scope="row">'.($config ? 
+				'<a href="'.$this->getURL('module='.$id.'&amp;conf=1').'" title"'.sprintf(__('Configure module "%s"'), html::escapeHTML($module['name'])).'">'.html::escapeHTML($module['name']).'</a>' : 
+				html::escapeHTML($module['name'])
+			).'</td>';
 
 			# Display score only for debug purpose
 			if (in_array('score', $cols) && $this->getSearch() !== null && defined('DC_DEBUG') && DC_DEBUG) {
-				$tds++;
-				echo
+				echo 
 				'<td class="module-version nowrap count"><span class="debug">'.$module['score'].'</span></td>';
 			}
 
 			if (in_array('version', $cols)) {
-				$tds++;
-				echo
+				echo 
 				'<td class="module-version nowrap count">'.html::escapeHTML($module['version']).'</td>';
 			}
 
 			if (in_array('current_version', $cols)) {
-				$tds++;
-				echo
+				echo 
 				'<td class="module-current-version nowrap count">'.html::escapeHTML($module['current_version']).'</td>';
 			}
 
 			if (in_array('desc', $cols)) {
-				$tds++;
-				echo
-				'<td class="module-desc maximal">'.html::escapeHTML(__($module['desc'])).'</td>';
+				echo 
+				'<td class="module-desc maximal">'.html::escapeHTML($module['desc']).'</td>';
 			}
 
 			if (in_array('distrib', $cols)) {
-				$tds++;
-				echo
-				'<td class="module-distrib">'.(self::isDistributedModule($id) ?
+				echo 
+				'<td class="module-distrib">'.(self::isDistributedModule($id) ? 
 					'<img src="images/dotclear_pw.png" alt="'.
-					__('Plugin from official distribution').'" title="'.
-					__('Plugin from official distribution').'" />'
+					__('Module from official distribution').'" title="'.
+					__('module from official distribution').'" />' 
 				: '').'</td>';
 			}
@@ -677,101 +637,32 @@
 				$buttons = $this->getActions($id, $module, $actions);
 
-				$tds++;
-				echo
+				echo 
 				'<td class="module-actions nowrap">'.
 
-				'<div>'.implode(' ', $buttons).'</div>'.
+				'<form action="'.$this->getURL().'" method="post">'.
+				'<div>'.
+				$this->core->formNonce().
+				form::hidden(array('module'), html::escapeHTML($id)).
+
+				implode(' ', $buttons).
+
+				'</div>'.
+				'</form>'.
 
 				'</td>';
 			}
 
-			echo
+			echo 
 			'</tr>';
 
-			# Other informations
-			if (in_array('expander', $cols)) {
-				echo
-				'<tr class="module-more"><td colspan="'.$tds.'" class="expand">';
-
-				if (!empty($module['author']) || !empty($module['details']) || !empty($module['support'])) {
-					echo
-					'<div><ul class="mod-more">';
-
-					if (!empty($module['author'])) {
-						echo
-						'<li class="module-author">'.__('Author:').' '.html::escapeHTML($module['author']).'</li>';
-					}
-
-					$more = array();
-					if (!empty($module['details'])) {
-						$more[] = '<a class="module-details" href="'.$module['details'].'">'.__('Details').'</a>';
-					}
-
-					if (!empty($module['support'])) {
-						$more[] = '<a class="module-support" href="'.$module['support'].'">'.__('Support').'</a>';
-					}
-
-					if (!empty($more)) {
-						echo
-						'<li>'.implode(' - ', $more).'</li>';
-					}
-
-					echo
-					'</ul></div>';
-				}
-
-				$config = !empty($module['root']) && file_exists(path::real($module['root'].'/_config.php'));
-
-				if ($config || !empty($module['section']) || !empty($module['section'])) {
-					echo
-					'<div><ul class="mod-more">';
-
-					if ($config) {
-						echo
-						'<li><a class="module-config" href="'.$this->getURL('module='.$id.'&amp;conf=1').'">'.__('Configure plugin').'</a></li>';
-					}
-
-					if (!empty($module['section'])) {
-						echo
-						'<li class="module-section">'.__('Section:').' '.html::escapeHTML($module['section']).'</li>';
-					}
-
-					if (!empty($module['section'])) {
-						echo
-						'<li class="module-tags">'.__('Tags:').' '.html::escapeHTML($module['tags']).'</li>';
-					}
-
-					echo
-					'</ul></div>';
-				}
-
-				echo
-				'</td></tr>';
-			}
-
 			$count++;
 		}
-		echo
+		echo 
 		'</table></div>';
 
 		if(!$count && $this->getSearch() === null) {
-			echo
-			'<p class="message">'.__('No plugins matched your search.').'</p>';
-		}
-
-		elseif ((in_array('checkbox', $cols) || $count > 1) && !empty($actions) && $this->core->auth->isSuperAdmin()) {
-			$buttons = $this->getGlobalActions($actions, in_array('checkbox', $cols));
-
-			if (!empty($buttons)) {
-				if (in_array('checkbox', $cols)) {
-					echo 
-					'<p class="checkboxes-helpers"></p>';
-				}
-				echo
-				'<div>'.implode(' ', $buttons).'</div>';
-			}
-		}
-		echo 
-		'</form>';
+			echo 
+			'<p class="message">'.__('No module matches your search.').'</p>';
+		}
 
 		return $this;
@@ -795,32 +686,32 @@
 
 				# Deactivate
-				case 'activate': if ($this->core->auth->isSuperAdmin() && $module['root_writable']) {
-					$submits[] =
-					'<input type="submit" name="activate['.html::escapeHTML($id).']" value="'.__('Activate').'" />';
+				case 'activate': if ($module['root_writable']) {
+					$submits[] = 
+					'<input type="submit" name="activate" value="'.__('Activate').'" />';
 				} break;
 
 				# Activate
-				case 'deactivate': if ($this->core->auth->isSuperAdmin() && $module['root_writable']) {
-					$submits[] =
-					'<input type="submit" name="deactivate['.html::escapeHTML($id).']" value="'.__('Deactivate').'" class="reset" />';
+				case 'deactivate': if ($module['root_writable']) {
+					$submits[] = 
+					'<input type="submit" name="deactivate" value="'.__('Deactivate').'" class="reset" />';
 				} break;
 
 				# Delete
-				case 'delete': if ($this->core->auth->isSuperAdmin() && $this->isDeletablePath($module['root'])) {
+				case 'delete': if ($this->isDeletablePath($module['root'])) {
 					$dev = !preg_match('!^'.$this->path_pattern.'!', $module['root']) && defined('DC_DEV') && DC_DEV ? ' debug' : '';
-					$submits[] =
-					'<input type="submit" class="delete '.$dev.'" name="delete['.html::escapeHTML($id).']" value="'.__('Delete').'" />';
+					$submits[] = 
+					'<input type="submit" class="delete '.$dev.'" name="delete" value="'.__('Delete').'" />';
 				} break;
 
 				# Install (from store)
-				case 'install': if ($this->core->auth->isSuperAdmin() && $this->path_writable) {
-					$submits[] =
-					'<input type="submit" name="install['.html::escapeHTML($id).']" value="'.__('Install').'" />';
+				case 'install': if ($this->path_writable) {
+					$submits[] = 
+					'<input type="submit" name="install" value="'.__('Install').'" />';
 				} break;
 
 				# Update (from store)
-				case 'update': if ($this->core->auth->isSuperAdmin() && $this->path_writable) {
-					$submits[] =
-					'<input type="submit" name="update['.html::escapeHTML($id).']" value="'.__('Update').'" />';
+				case 'update': if ($this->path_writable) {
+					$submits[] = 
+					'<input type="submit" name="update" value="'.__('Update').'" />';
 				} break;
 
@@ -838,61 +729,4 @@
 		}
 
-		return $submits;
-	}
-
-	/**
-	 * Get global action buttons to add to modules list.
-	 *
-	 * @param	array	$actions	      Actions keys
-	 * @param boolean   $with_selection Limit action to selected modules
-	 * @return	Array of actions buttons
-	 */
-	protected function getGlobalActions($actions, $with_selection=false)
-	{
-		$submits = array();
-
-		# Use loop to keep requested order
-		foreach($actions as $action) {
-			switch($action) {
-
-				# Deactivate
-				case 'activate': if ($this->core->auth->isSuperAdmin() && $this->path_writable) {
-					$submits[] =
-					'<input type="submit" name="activate" value="'.($with_selection ?
-						__('Activate selected plugins') :
-						__('Activate all plugins from this list')
-					).'" />';
-				} break;
-
-				# Activate
-				case 'deactivate': if ($this->core->auth->isSuperAdmin() && $this->path_writable) {
-					$submits[] =
-					'<input type="submit" name="deactivate" value="'.($with_selection ?
-						__('Deactivate selected plugins') :
-						__('Deactivate all plugins from this list')
-					).'" />';
-				} break;
-
-				# Update (from store)
-				case 'update': if ($this->core->auth->isSuperAdmin() && $this->path_writable) {
-					$submits[] =
-					'<input type="submit" name="update" value="'.($with_selection ?
-						__('Update selected plugins') :
-						__('Update all plugins from this list')
-					).'" />';
-				} break;
-
-				# Behavior
-				case 'behavior':
-
-					# --BEHAVIOR-- adminModulesListGetGlobalActions
-					$tmp = $this->core->callBehavior('adminModulesListGetGlobalActions', $this, $with_selection);
-
-					if (!empty($tmp)) {
-						$submits[] = $tmp;
-					}
-				break;
-			}
-		}
 
 		return $submits;
@@ -904,31 +738,70 @@
 	 * @note	Set a notice on success through dcPage::addSuccessNotice
 	 * @throw	Exception	Module not find or command failed
+	 * @param	string	$prefix		Prefix used on behaviors
 	 * @return	Null
 	 */
-	public function doActions()
-	{
-		if (empty($_POST) || !empty($_REQUEST['conf'])
-		|| !$this->isWritablePath()) {
+	public function doActions($prefix)
+	{
+		if (empty($_POST) || !empty($_REQUEST['conf']) 
+		|| !$this->core->auth->isSuperAdmin() || !$this->isWritablePath()) {
 			return null;
 		}
 
-		$modules = !empty($_POST['modules']) && is_array($_POST['modules']) ? array_values($_POST['modules']) : array();
-
-		if ($this->core->auth->isSuperAdmin() && !empty($_POST['delete'])) {
-
-			if (is_array($_POST['delete'])) {
-				$modules = array_keys($_POST['delete']);
-			}
-
-			$list = $this->modules->getDisabledModules();
-
-			$failed = false;
-			$count = 0;
-			foreach($modules as $id)
-			{
-				if (!isset($list[$id])) {
+		# List actions
+		if (!empty($_POST['module'])) {
+
+			$id = $_POST['module'];
+
+			if (!empty($_POST['activate'])) {
+
+				$enabled = $this->modules->getDisabledModules();
+				if (!isset($enabled[$id])) {
+					throw new Exception(__('No such module.'));
+				}
+
+				# --BEHAVIOR-- moduleBeforeActivate
+				$this->core->callBehavior($prefix.'BeforeActivate', $id);
+
+				$this->modules->activateModule($id);
+
+				# --BEHAVIOR-- moduleAfterActivate
+				$this->core->callBehavior($prefix.'AfterActivate', $id);
+
+				dcPage::addSuccessNotice(__('Module has been successfully activated.'));
+				http::redirect($this->getURL());
+			}
+
+			elseif (!empty($_POST['deactivate'])) {
+
+				if (!$this->modules->moduleExists($id)) {
+					throw new Exception(__('No such module.'));
+				}
+
+				$module = $this->modules->getModules($id);
+				$module['id'] = $id;
+
+				if (!$module['root_writable']) {
+					throw new Exception(__('You don\'t have permissions to deactivate this module.'));
+				}
+
+				# --BEHAVIOR-- moduleBeforeDeactivate
+				$this->core->callBehavior($prefix.'BeforeDeactivate', $module);
+
+				$this->modules->deactivateModule($id);
+
+				# --BEHAVIOR-- moduleAfterDeactivate
+				$this->core->callBehavior($prefix.'AfterDeactivate', $module);
+
+				dcPage::addSuccessNotice(__('Module has been successfully deactivated.'));
+				http::redirect($this->getURL());
+			}
+
+			elseif (!empty($_POST['delete'])) {
+
+				$disabled = $this->modules->getDisabledModules();
+				if (!isset($disabled[$id])) {
 
 					if (!$this->modules->moduleExists($id)) {
-						throw new Exception(__('No such plugin.'));
+						throw new Exception(__('No such module.'));
 					}
 
@@ -937,15 +810,14 @@
 
 					if (!$this->isDeletablePath($module['root'])) {
-						$failed = true;
-						continue;
+						throw new Exception(__("You don't have permissions to delete this module."));
 					}
 
 					# --BEHAVIOR-- moduleBeforeDelete
-					$this->core->callBehavior('pluginBeforeDelete', $module);
+					$this->core->callBehavior($prefix.'BeforeDelete', $module);
 
 					$this->modules->deleteModule($id);
 
 					# --BEHAVIOR-- moduleAfterDelete
-					$this->core->callBehavior('pluginAfterDelete', $module);
+					$this->core->callBehavior($prefix.'AfterDelete', $module);
 				}
 				else {
@@ -953,159 +825,50 @@
 				}
 
-				$count++;
-			}
-
-			if (!$count && $failed) {
-				throw new Exception(__("You don't have permissions to delete this plugin."));
-			}
-			elseif ($failed) {
-				dcPage::addWarningNotice(__('Some plugins have not been delete.'));
-			}
-			else {
-				dcPage::addSuccessNotice(
-					__('Plugin has been successfully deleted.', 'Plugins have been successuflly deleted.', $count)
+				dcPage::addSuccessNotice(__('Module has been successfully deleted.'));
+				http::redirect($this->getURL());
+			}
+
+			elseif (!empty($_POST['install'])) {
+
+				$updated = $this->store->get();
+				if (!isset($updated[$id])) {
+					throw new Exception(__('No such module.'));
+				}
+
+				$module = $updated[$id];
+				$module['id'] = $id;
+
+				$dest = $this->getPath().'/'.basename($module['file']);
+
+				# --BEHAVIOR-- moduleBeforeAdd
+				$this->core->callBehavior($prefix.'BeforeAdd', $module);
+
+				$ret_code = $this->store->process($module['file'], $dest);
+
+				# --BEHAVIOR-- moduleAfterAdd
+				$this->core->callBehavior($prefix.'AfterAdd', $module);
+
+				dcPage::addSuccessNotice($ret_code == 2 ?
+					__('Module has been successfully updated.') :
+					__('Module has been successfully installed.')
 				);
-			}
-			http::redirect($this->getURL());
-		}
-
-		elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['install'])) {
-
-			if (is_array($_POST['install'])) {
-				$modules = array_keys($_POST['install']);
-			}
-
-			$list = $this->store->get();
-
-			if (empty($list)) {
-				throw new Exception(__('No such plugin.'));
-			}
-
-			$count = 0;
-			foreach($list as $id => $module) {
-
-				if (!in_array($id, $modules)) {
-					continue;
-				}
-
-				$dest = $this->getPath().'/'.basename($module['file']);
-
-				# --BEHAVIOR-- moduleBeforeAdd
-				$this->core->callBehavior('pluginBeforeAdd', $module);
-
-				$this->store->process($module['file'], $dest);
-
-				# --BEHAVIOR-- moduleAfterAdd
-				$this->core->callBehavior('pluginAfterAdd', $module);
-
-				$count++;
-			}
-
-			dcPage::addSuccessNotice(
-				__('Plugin has been successfully installed.', 'Plugins have been successuflly installed.', $count)
-			);
-			http::redirect($this->getURL());
-		}
-
-		elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['activate'])) {
-
-			if (is_array($_POST['activate'])) {
-				$modules = array_keys($_POST['activate']);
-			}
-
-			$list = $this->modules->getDisabledModules();
-			if (empty($list)) {
-				throw new Exception(__('No such plugin.'));
-			}
-
-			$count = 0;
-			foreach($list as $id => $module) {
-
-				if (!in_array($id, $modules)) {
-					continue;
-				}
-
-				# --BEHAVIOR-- moduleBeforeActivate
-				$this->core->callBehavior('pluginBeforeActivate', $id);
-
-				$this->modules->activateModule($id);
-
-				# --BEHAVIOR-- moduleAfterActivate
-				$this->core->callBehavior('pluginAfterActivate', $id);
-
-				$count++;
-			}
-
-			dcPage::addSuccessNotice(
-				__('Plugin has been successfully activated.', 'Plugins have been successuflly activated.', $count)
-			);
-			http::redirect($this->getURL());
-		}
-
-		elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['deactivate'])) {
-
-			if (is_array($_POST['deactivate'])) {
-				$modules = array_keys($_POST['deactivate']);
-			}
-
-			$list = $this->modules->getModules();
-			if (empty($list)) {
-				throw new Exception(__('No such plugin.'));
-			}
-
-			$failed = false;
-			$count = 0;
-			foreach($list as $id => $module) {
-
-				if (!in_array($id, $modules)) {
-					continue;
-				}
-
-				if (!$module['root_writable']) {
-					$failed = true;
-					continue;
-				}
-
-				$module[$id] = $id;
-
-				# --BEHAVIOR-- moduleBeforeDeactivate
-				$this->core->callBehavior('pluginBeforeDeactivate', $module);
-
-				$this->modules->deactivateModule($id);
-
-				# --BEHAVIOR-- moduleAfterDeactivate
-				$this->core->callBehavior('pluginAfterDeactivate', $module);
-
-				$count++;
-			}
-
-			if ($failed) {
-				dcPage::addWarningNotice(__('Some plugins have not been deactivated.'));
-			}
-			else {
-				dcPage::addSuccessNotice(
-					__('Plugin has been successfully deactivated.', 'Plugins have been successuflly deactivated.', $count)
-				);
-			}
-			http::redirect($this->getURL());
-		}
-
-		elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['update'])) {
-
-			if (is_array($_POST['update'])) {
-				$modules = array_keys($_POST['update']);
-			}
-
-			$list = $this->store->get(true);
-			if (empty($list)) {
-				throw new Exception(__('No such plugin.'));
-			}
-
-			$count = 0;
-			foreach($list as $module) {
-
-				if (!in_array($module['id'], $modules)) {
-					continue;
-				}
+				http::redirect($this->getURL());
+			}
+
+			elseif (!empty($_POST['update'])) {
+
+				$updated = $this->store->get(true);
+				if (!isset($updated[$id])) {
+					throw new Exception(__('No such module.'));
+				}
+
+				if (!$this->modules->moduleExists($id)) {
+					throw new Exception(__('No such module.'));
+				}
+
+				$tab = count($updated) > 1 ? '' : '#'.$prefix;
+
+				$module = $updated[$id];
+				$module['id'] = $id;
 
 				if (!self::$allow_multi_install) {
@@ -1120,24 +883,23 @@
 
 				# --BEHAVIOR-- moduleBeforeUpdate
-				$this->core->callBehavior('pluginBeforeUpdate', $module);
+				$this->core->callBehavior($prefix.'BeforeUpdate', $module);
 
 				$this->store->process($module['file'], $dest);
 
 				# --BEHAVIOR-- moduleAfterUpdate
-				$this->core->callBehavior('pluginAfterUpdate', $module);
-
-				$count++;
-			}
-
-			$tab = $count && $count == count($list) ? '#plugins' : '#update';
-
-			dcPage::addSuccessNotice(
-				__('Plugin has been successfully updated.', 'Plugins have been successuflly updated.', $count)
-			);
-			http::redirect($this->getURL().$tab);
-		}
-
+				$this->core->callBehavior($prefix.'AfterUpdate', $module);
+
+				dcPage::addSuccessNotice(__('Module has been successfully updated.'));
+				http::redirect($this->getURL().$tab);
+			}
+			else {
+
+				# --BEHAVIOR-- adminModulesListDoActions
+				$this->core->callBehavior('adminModulesListDoActions', $this, $id, $prefix);
+
+			}
+		}
 		# Manual actions
-		elseif (!empty($_POST['upload_pkg']) && !empty($_FILES['pkg_file'])
+		elseif (!empty($_POST['upload_pkg']) && !empty($_FILES['pkg_file']) 
 			|| !empty($_POST['fetch_pkg']) && !empty($_POST['pkg_url']))
 		{
@@ -1148,5 +910,5 @@
 			if (!empty($_POST['upload_pkg'])) {
 				files::uploadStatus($_FILES['pkg_file']);
-
+				
 				$dest = $this->getPath().'/'.$_FILES['pkg_file']['name'];
 				if (!move_uploaded_file($_FILES['pkg_file']['tmp_name'], $dest)) {
@@ -1161,23 +923,16 @@
 
 			# --BEHAVIOR-- moduleBeforeAdd
-			$this->core->callBehavior('pluginBeforeAdd', null);
+			$this->core->callBehavior($prefix.'BeforeAdd', null);
 
 			$ret_code = $this->store->install($dest);
 
 			# --BEHAVIOR-- moduleAfterAdd
-			$this->core->callBehavior('pluginAfterAdd', null);
+			$this->core->callBehavior($prefix.'AfterAdd', null);
 
 			dcPage::addSuccessNotice($ret_code == 2 ?
-				__('Plugin has been successfully updated.') :
-				__('Plugin has been successfully installed.')
+				__('Module has been successfully updated.') :
+				__('Module has been successfully installed.')
 			);
-			http::redirect($this->getURL().'#plugins');
-		}
-
-		else {
-
-			# --BEHAVIOR-- adminModulesListDoActions
-			$this->core->callBehavior('adminModulesListDoActions', $this, $modules, 'plugin');
-
+			http::redirect($this->getURL().'#'.$prefix);
 		}
 
@@ -1247,5 +1002,5 @@
 			return false;
 		}
-
+		
 		if (!empty($_REQUEST['module']) && empty($id)) {
 			$id = $_REQUEST['module'];
@@ -1253,5 +1008,5 @@
 
 		if (!$this->modules->moduleExists($id)) {
-			$this->core->error->add(__('Unknow plugin ID'));
+			$this->core->error->add(__('Unknow module ID'));
 			return false;
 		}
@@ -1262,5 +1017,5 @@
 
 		if (!file_exists($file)) {
-			$this->core->error->add(__('This plugin has no configuration file.'));
+			$this->core->error->add(__('This module has no configuration file.'));
 			return false;
 		}
@@ -1325,5 +1080,5 @@
 				echo
 				'<form id="module_config" action="'.$this->getURL('conf=1').'" method="post" enctype="multipart/form-data">'.
-				'<h3>'.sprintf(__('Configure "%s"'), html::escapeHTML($this->config_module['name'])).'</h3>'.
+				'<h3>'.sprintf(__('Configure plugin "%s"'), html::escapeHTML($this->config_module['name'])).'</h3>'.
 				'<p><a class="back" href="'.$this->getRedir().'">'.__('Back').'</a></p>';
 			}
@@ -1370,6 +1125,5 @@
 	public function displayModules($cols=array('name', 'config', 'version', 'desc'), $actions=array(), $nav_limit=false)
 	{
-		echo
-		'<form action="'.$this->getURL().'" method="post" class="modules-form-actions">'.
+		echo 
 		'<div id="'.html::escapeHTML($this->list_id).'" class="modules'.(in_array('expander', $cols) ? ' expandable' : '').' one-box">';
 
@@ -1399,33 +1153,15 @@
 			$distrib = self::isDistributedModule($id) ? ' dc-box' : '';
 
-			$line =
-			'<div class="box '.($current ? 'medium current-theme' : 'theme').$distrib.'">';
-
-			if (in_array('name', $cols) && !$current) {
-				$line .=
-				'<h4 class="module-name">';
-
-				if (in_array('checkbox', $cols)) {
-					$line .=
-					'<label for="'.html::escapeHTML($this->list_id).'_modules_'.html::escapeHTML($id).'">'.
-					form::checkbox(array('modules['.$count.']', html::escapeHTML($this->list_id).'_modules_'.html::escapeHTML($id)), html::escapeHTML($id)).
-					html::escapeHTML($module['name']).
-					'</label>';
-
-				}
-				else {
-					$line .=
-					form::hidden(array('modules['.$count.']'), html::escapeHTML($id)).
-					html::escapeHTML($module['name']);
-				}
-
-				$line .=
-				$this->core->formNonce().
-				'</h4>';
+			$line = 
+			'<div class="box '.($current ? 'medium current-theme' : 'small theme').$distrib.'">';
+
+			if (in_array('name', $cols)) {
+				$line .= 
+				'<h4 class="module-name">'.html::escapeHTML($module['name']).'</h4>';
 			}
 
 			# Display score only for debug purpose
 			if (in_array('score', $cols) && $this->getSearch() !== null && defined('DC_DEBUG') && DC_DEBUG) {
-				$line .=
+				$line .= 
 				'<p class="module-score debug">'.sprintf(__('Score: %s'), $module['score']).'</p>';
 			}
@@ -1445,53 +1181,30 @@
 				}
 
-				$line .=
+				$line .= 
 				'<div class="module-sshot"><img src="'.$sshot.'" alt="'.
 				sprintf(__('%s screenshot.'), html::escapeHTML($module['name'])).'" /></div>';
 			}
 
-			$line .=
-			'<div class="module-infos toggle-bloc">';
-
-			if (in_array('name', $cols) && $current) {
-				$line .=
-				'<h4 class="module-name">';
-
-				if (in_array('checkbox', $cols)) {
-					$line .=
-					'<label for="'.html::escapeHTML($this->list_id).'_modules_'.html::escapeHTML($id).'">'.
-					form::checkbox(array('modules['.$count.']', html::escapeHTML($this->list_id).'_modules_'.html::escapeHTML($id)), html::escapeHTML($id)).
-					html::escapeHTML($module['name']).
-					'</label>';
-				}
-				else {
-					$line .=
-					form::hidden(array('modules['.$count.']'), html::escapeHTML($id)).
-					html::escapeHTML($module['name']);
-				}
-
-				$line .=
-				'</h4>';
-			}
-
-			$line .=
+			$line .= 
+			'<div class="module-infos toggle-bloc">'.
 			'<p>';
 
 			if (in_array('desc', $cols)) {
-				$line .=
-				'<span class="module-desc">'.html::escapeHTML(__($module['desc'])).'</span> ';
+				$line .= 
+				'<span class="module-desc">'.html::escapeHTML($module['desc']).'</span> ';
 			}
 
 			if (in_array('author', $cols)) {
-				$line .=
+				$line .= 
 				'<span class="module-author">'.sprintf(__('by %s'),html::escapeHTML($module['author'])).'</span> ';
 			}
 
 			if (in_array('version', $cols)) {
-				$line .=
+				$line .= 
 				'<span class="module-version">'.sprintf(__('version %s'),html::escapeHTML($module['version'])).'</span> ';
 			}
 
 			if (in_array('current_version', $cols)) {
-				$line .=
+				$line .= 
 				'<span class="module-current-version">'.sprintf(__('(current version %s)'),html::escapeHTML($module['current_version'])).'</span> ';
 			}
@@ -1499,9 +1212,9 @@
 			if (in_array('parent', $cols) && !empty($module['parent'])) {
 				if ($this->modules->moduleExists($module['parent'])) {
-					$line .=
+					$line .= 
 					'<span class="module-parent-ok">'.sprintf(__('(built on "%s")'),html::escapeHTML($module['parent'])).'</span> ';
 				}
 				else {
-					$line .=
+					$line .= 
 					'<span class="module-parent-missing">'.sprintf(__('(requires "%s")'),html::escapeHTML($module['parent'])).'</span> ';
 				}
@@ -1515,10 +1228,10 @@
 
 				if ($has_details) {
-					$line .=
+					$line .= 
 					'<a class="module-details" href="'.$module['details'].'">'.__('Details').'</a>';
 				}
 
 				if ($has_support) {
-					$line .=
+					$line .= 
 					' - <a class="module-support" href="'.$module['support'].'">'.__('Support').'</a>';
 				}
@@ -1528,11 +1241,11 @@
 			}
 
-			$line .=
+			$line .= 
 			'</p>'.
 			'</div>';
 
-			$line .=
+			$line .= 
 			'<div class="module-actions toggle-bloc">';
-
+			
 			# Plugins actions
 			if ($current) {
@@ -1543,5 +1256,5 @@
 						http::concatURL($this->core->blog->settings->system->themes_url, '/'.$id) :
 						http::concatURL($this->core->blog->url, $this->core->blog->settings->system->themes_url.'/'.$id);
-					$line .=
+					$line .= 
 					'<p><a href="'.$theme_url.'/style.css">'.__('View stylesheet').'</a></p>';
 				}
@@ -1550,10 +1263,10 @@
 
 				if (file_exists(path::real($this->core->blog->themes_path.'/'.$id).'/_config.php')) {
-					$line .=
-					'<p><a href="'.$this->getURL('module='.$id.'&amp;conf=1', false).'" class="button submit">'.__('Configure theme').'</a></p>';
+					$line .= 
+					'<p><a href="'.$this->getURL('module='.$id.'&conf=1', false).'" class="button">'.__('Configure theme').'</a></p>';
 				}
 
 				# --BEHAVIOR-- adminCurrentThemeDetails
-				$line .=
+				$line .= 
 				$this->core->callBehavior('adminCurrentThemeDetails', $this->core, $id, $module);
 
